local _orig_function = Drill.on_sabotage_SO_started

function Drill:check_should_tase(saboteur)
	local c_damage = saboteur:character_damage()
	if c_damage._char_tweak.can_be_tased == false then
		--managers.chat:send_message(ChatManager.GAME, managers.network.account:username() or "player", 'can not be tased.')
		return false
	end
	local current_auto_repair_level_1 = self._skill_upgrades.auto_repair_level_1 or 0
	local current_auto_repair_level_2 = self._skill_upgrades.auto_repair_level_2 or 0
	if current_auto_repair_level_1 > 0 or current_auto_repair_level_2 > 0 then
		if saboteur:contour() then
			saboteur:contour():add("mark_unit_dangerous", true)
		end
		local tase_chance = 0
		if current_auto_repair_level_1 > 0 then
			tase_chance = tase_chance + 0.3
		end
		if current_auto_repair_level_2 > 0 then
			tase_chance = tase_chance + 0.3
		end
		if Network:is_server() and math.random() < tase_chance then
			return true
		end
	end
	--managers.chat:send_message(ChatManager.GAME, managers.network.account:username() or "player", 'bad luck.')
	return false
end

local function manual_tase_unit(unit)
	local c_dmg = unit:character_damage()
	local attack_data = {
		name_id = 'taser',
		damage_effect = 0,
		pos = unit:position(),
		variant = "taser_tased",
		damage = 0,
		col_ray = {
			position = unit:position(),
			hit_position = unit:position(),
			ray = unit:position(),
			body = unit:body("body"),
			unit = unit,
			distance = 50
		}
	}
	unit:brain():set_objective(nil)
	c_dmg:damage_melee(attack_data)
	if c_dmg._tase_effect then
		World:effect_manager():fade_kill(c_dmg._tase_effect)
	end
	c_dmg._tase_effect = World:effect_manager():spawn(c_dmg._tase_effect_table)
end

function Drill:on_sabotage_SO_started(saboteur)
	local should_tase = self:check_should_tase(saboteur)
	if Network:is_server() and should_tase then
		manual_tase_unit(saboteur)
		if saboteur:contour() then
			saboteur:contour():add("medic_heal", true, 2, tweak_data.contour.character_interactable.standard_color)
			saboteur:contour():flash("medic_heal", 0.2)
		end
		--managers.chat:send_message(ChatManager.GAME, managers.network.account:username() or "player", 'successfully tased.')
		self:on_sabotage_SO_failed(saboteur)
		return
	end
	return _orig_function(self, saboteur)
end
